#!BPY
"""
Name: 'Farm Render'
Blender: 241
Group: 'Render' 
Tip: 'Render using other machines with Blender and this script!'
"""

##########################################################
#GUI Created using RipSting's Blender-Python GUI designer#
#Download at Http://oregonstate.edu/~dennisa/Blender/BPG/#
##########################################################

import Blender
import os
from Blender.BGL import *
from Blender.Draw import *

ShareLoc = os.getenv('BlReFa') 

def draw():
	global Exit, Listen, Submit, Browse, ShareLoc

	glClearColor(0.753, 0.753, 0.753, 0.0)
	glClear(GL_COLOR_BUFFER_BIT)


	#glColor3f(0.000, 0.000, 0.000)
	#glRasterPos2i(8, 64)
	#Text('Pole Pause:')
	#glRasterPos2i(8, 112)
	#Text('Shared Directory:')
	glColor3f(0.000, 0.500, 0.000)
	glRasterPos2i(8, 42)
	Text('Farm Render:')


	Button('Exit', 1, 8, 8, 79, 23, 'Exits the script.')
	Button('Activate', 2, 88, 32, 79, 23, 'Activates the submitted job.')
	Button('Submit', 3, 88, 8, 79, 23, 'Submit the current animation.')
	#Button('...', 4, 144, 80, 23, 23, 'Browse to find a directory.')

	#ShareLoc = String('', 5, 8, 80, 135, 23, ShareLoc.val, 512, 'The shared directory.')


	#Extn = String('Extn: ', 6, 8, 32, 79, 23, Extn.val, 512, 'The text to append the filename with.')
	

def event(evt, val):
	if (evt== QKEY and not val): Exit()
def bevent(evt):
	global Exit, Listen, Submit, Browse, PolePause, ShareLoc, Listenable, eType
	
	if evt == 1: #Exit
		Exit()

	elif evt == 2: #Activate
		JobTxt = open (Blender.sys.join(ShareLoc, 'Job.txt'), 'r+')
		JobTxt.write('a')
		JobTxt.close()
		
	elif evt == 3: #Submit
		JobTxt = open (Blender.sys.join(ShareLoc, 'Job.txt'), 'r+')
		if JobTxt.read (1) == 'd':
			scn = Blender.Scene.GetCurrent()
			open (Blender.sys.join(ShareLoc, 'ExitPin'), 'w').close()
			scn.addScriptLink ('FR_Listen.py', 'OnLoad')
			Blender.Save (Blender.sys.join(ShareLoc, 'FR.blend'), 1)
			scn.clearScriptLinks (['FR_Listen.py'])
			JobTxt.seek (0)
			JobTxt.write ('i')
			ctxt = scn.getRenderingContext()
			cdf = ctxt.startFrame()
			
			while cdf <= ctxt.endFrame():
				JobTxt.write ('w')
				cdf = cdf + 1
			
			#JobTxt.seek (0)	
			#JobTxt.write('a')
			JobTxt.close()
			print ('Job submitted.')
		else:
			print ('ERROR DURUNG SUBMITION:\n\tA job is already in progress!')
										

	elif evt == 4: #Browse
		print ('Not implemented yet!')

	Blender.Redraw()

Register(draw, event, bevent)